/*
 File:          CSICommand.m

 Description:   Chicken interpreter results parser

 Author:        Kon Lovett
*/

#import "CSICommand.h"

@implementation CSICommand

- (void)dealloc
{
    [description release];
    [name release];
    [target release];
    [super dealloc];
}

- (id)initWithDescription:(NSString *)desc name:(NSString *)nam target:(id)trg selector:(SEL)sel count:(int)cnt
{
    if (self = [super init]) {
        description = [desc retain];
        name = [nam retain];
        target = [trg retain];
        selector = sel;
        count = cnt;
    }
    return self;
}

- (NSString *)description
{
    return description;
}

- (NSString *)name
{
    return name;
}

- (id)target
{
    return target;
}

- (SEL)selector
{
    return selector;
}

- (int)count
{
    return count;
}

- (NSDictionary *)parseResult:(NSString *)result
{
    NSDictionary *dict = nil;
    if (0 < count) dict = [NSMutableDictionary dictionaryWithCapacity: count];
    [target performSelector: selector withObject: result withObject: dict];
    return dict;
}

@end
